/*
 *  (C) Copyright 2001 Mulle kybernetiK. All rights reserved.
 *
 *  Permission to use, copy, modify and distribute this software and its
 *  documentation is hereby granted, provided that both the copyright notice
 *  and this permission notice appear in all copies of the software, derivative
 *  works or modified versions, and any portions thereof, and that both notices
 *  appear in supporting documentation, and that credit is given to
 *  Mulle kybernetiK in all documents and publicity pertaining to direct or
 *  indirect use of this code or its derivatives.
 *
 *  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF WHICH
 *  MAY HAVE SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE USE OF THIS
 *  SOFTWARE IN ITS "AS IS" CONDITION. THE COPYRIGHT HOLDER DISCLAIMS ANY
 *  LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING DIRECTLY OR
 *  INDIRECTLY FROM THE USE OF THIS SOFTWARE OR OF ANY DERIVATIVE WORK.
 *
 *  Coded by Nat!
 *
 *  $Id$
 *
 *  $Log$
 */
#import "Stopwatch.h"
#include <unistd.h>

@implementation Stopwatch


+ (void) delay:(unsigned long) milliseconds
{
   struct timeval   wait;

   wait.tv_sec  = milliseconds / 1000;
   wait.tv_usec = (milliseconds % 1000) * 1000;
   select( 0, NULL, NULL, NULL, &wait);  // use select as sleepMs
}


- (void) start
{
   gettimeofday( &_start, NULL);
   running = YES;
}


- (void) calcElapsed
{
   long   us;
   int    carry;
   
   if( ! running)
      [NSException raise:NSGenericException
                  format:@"Stopwatch %@ ain't running", self];
   gettimeofday( &_stop, NULL);

   if( carry = _stop.tv_usec < _start.tv_usec)
      us = 1000000 - _start.tv_usec + _stop.tv_usec;
   else
      us = _stop.tv_usec - _start.tv_usec;
      
   elapsed = (_stop.tv_sec - _start.tv_sec - carry) * 1000 + us / 1000;
}


- (void) stop
{
   [self calcElapsed];
   running = NO;
}   


- (unsigned long) elapsedMilliseconds
{
   if( running)
      [self calcElapsed];
   return( elapsed);
}


@end
